<template>
  <div class="bargainList pagePadding">
    <div
      v-if="powers && powers.length > 0 && powers.some((item) => item == '001')"
    >
      <ex-table
        v-loading="loading"
        :table="table"
        :data="tableData"
        :columns="columns"
        :page="pageInfo"
        :size="size"
        @page-curr-change="handlePageChange"
        @page-size-change="handleSizeChange"
        @screen-reset="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
        @screen-submit="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
      >
        <template #table-header="{}">
          <div style="width: 100%">
            <el-row style="padding: 0 0 0 80px">
              <el-col :span="4" style="width: 130px">
                <el-select
                  :size="searchSize"
                  v-model="parmValue.status"
                  clearable
                  placeholder="状态"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option
                    v-for="item in options"
                    :key="item.id"
                    :label="item.label"
                    :value="item.id"
                  >
                  </el-option>
                </el-select>
              </el-col>
              <el-col :span="4" style="width: 301px; padding: 0 0 0 10px">
                <period-date-picker
                  :start="parmValue.start"
                  :end="parmValue.end"
                  :width="'134px'"
                  :size="searchSize"
                  @timeReturned="handleTime"
                />
              </el-col>

              <el-col :span="4" style="width: 420px; padding: 0 0 0 10px">
                <el-input
                  clearable
                  :size="searchSize"
                  placeholder="关键字"
                  v-model="s_input"
                  @blur="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                  class="input-with-select"
                >
                  <el-select
                    style="width: 140px"
                    v-model="select"
                    slot="prepend"
                    placeholder="请选择"
                  >
                    <el-option label="议价单编号" value="1" />
                    <el-option label="反馈商品编号" value="2" />
                    <el-option label="咨询单编号" value="3" />
                  </el-select>
                  <el-button
                    slot="append"
                    icon="el-icon-search"
                    @click="
                      pageInfo.curr = 1;
                      parmValue.page = 1;
                      searchList();
                    "
                  ></el-button>
                </el-input>
              </el-col>

              <el-col :span="3" style="width: 66px; float: right">
                <el-button
                  :size="searchSize"
                  type="primary"
                  style="float: right; margin-left: 5px"
                  @click="searchList"
                >
                  刷新
                </el-button>
              </el-col>
              <el-col :span="4" class="fr" style="width: 66px">
                <el-button
                  type="warning"
                  class="fr"
                  :size="searchSize"
                  @click="restSearch"
                >
                  重置
                </el-button>
              </el-col>
            </el-row>
          </div>
        </template>
        <template #good_img="{ scope }">
          <div
            v-if="scope.row.good_img"
            style="width: 20px; height: 20px"
            class="hover"
            v-viewer
          >
            <img
              :src="scope.row.good_img"
              style="display: inline-block; width: 100%; height: 100%"
              alt=""
            />
          </div>
        </template>
        <template #status="{ scope }">
          <el-tag
            :size="tablebtnSize"
            :type="scope.row.status == '0' ? 'warning' : ''"
            v-text="
              (options.find((item) => item.id == scope.row.status) || {})
                .label || '--'
            "
          ></el-tag>
        </template>
        <template #good_name="{ scope }">
          <span>{{ scope.row.good_name }}</span>
          <span
            v-for="(si, sii) in scope.row.specinfo"
            :key="si.spec_value_id + sii"
          >
            {{ sii == 0 ? "__" : "--" }}{{ si.spec_name }}[{{
              si.spec_value_name
            }}]</span
          >
        </template>
        <template #can="{ scope }">
          <span v-for="(si, sii) in scope.row.can" :key="si.id + sii">
            <span v-if="sii !== 0">_</span>{{ si.name }}</span
          >
        </template>
        <template #operation="{ scope }">
          <el-tooltip
            v-if="powers.some((item) => item == '007')"
            effect="dark"
            content="详情"
            placement="top"
          >
            <i
              class="el-icon-view tb-icon"
              @click="
                routeGoto('bargainListDetail', {
                  id: scope.row.bargainNo,
                  type: 'view',
                })
              "
            ></i>
          </el-tooltip>
        </template>
      </ex-table>
    </div>
    <div v-else>
      <no-auth></no-auth>
    </div>
  </div>
</template>
   <script>
import mixinPage from "@/mixins/elPaginationHandle";
import resToken from "@/mixins/resToken";
import asyncRequest from "@/apis/service/sellOut/bargainList";
import { listCol } from "./columns";
import { mapGetters } from "vuex";

export default {
  name: "bargainList",
  mixins: [mixinPage, resToken],
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      let tran =
        this.$store.getters.btnList.find(
          (item) => item.menu_route == "bargainList"
        ) || {};
      if (tran && tran.action && tran.action.length > 0) {
        return tran.action;
      } else {
        return [];
      }
    },
  },
  data() {
    return {
      select: "1",
      s_input: "",
      customerCode: [], //客户公司code
      options: [
        { id: "1", label: "待主管审批" },
        { id: "2", label: "待财务专员审批" },
        { id: "3", label: "待财务主管审批" },
        { id: "4", label: "审批通过" },
        { id: "5", label: "主管驳回" },
        { id: "6", label: "财务主管驳回" },
        { id: "7", label: "已取消议价" },
      ],

      sitem: null,

      loading: true,
      showModel: false,
      isDetail: false,
      modelId: 0,
      parmValue: {
        order_type: "2",
        returnCode: "", //售后单号
        outCode: "", //发货申请单号，
        status: "", //售后申请单处理状态
        orderCode: "", //销售单号
        good_code: "", //商品编号
        except_code: "", //期望意愿
        apply_name: "", //申请人名称
        start: "",
        end: "",
        customer_code: "", //客户公司code
        good_name: "", //商品名称
        page: 1, // 页码
        size: 15, // 每页显示条数
      },
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: listCol,

      resultValue: "", //处理结果
    };
  },
  mounted() {
    this.searchList();
  },

  methods: {
    restSearch() {
      this.customerCode = [];
      this.select = "1";
      this.s_input = "";
      this.parmValue = {
        order_type: "2",
        returnCode: "", //售后单号
        outCode: "", //发货申请单号，
        status: "", //售后申请单处理状态
        orderCode: "", //销售单号
        good_code: "", //商品编号
        except_code: "", //期望意愿
        apply_name: "", //申请人名称
        start: "",
        end: "",
        customer_code: "", //客户公司code
        good_name: "", //商品名称
        page: 1, // 页码
        size: 15, // 每页显示条数
      };
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.searchList();
    },

    openModal(id, isDetail, sitem) {
      this.showModel = true;
      this.modelId = id;
      this.isDetail = isDetail;
      this.sitem = sitem;
    },
    async deleteById(id, status) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            id: id,
            status: status === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    // 列表搜索
    async searchList() {
      if (this.parmValue.start !== "" && this.parmValue.end === "") {
        this.$message.warning("结束时间不能为空!");
        return;
      }
      if (this.parmValue.start == "" && this.parmValue.end != "") {
        this.$message.warning("开始时间不能为空!");
        return;
      }
      this.loading = true;
      this.parmValue.returnCode = this.select === "1" ? this.s_input : "";
      this.parmValue.orderCode = this.select === "2" ? this.s_input : "";
      this.parmValue.outCode = this.select === "3" ? this.s_input : "";
      this.parmValue.good_code = this.select === "4" ? this.s_input : "";
      this.parmValue.good_name = this.select === "5" ? this.s_input : "";
      this.parmValue.apply_name = this.select === "6" ? this.s_input : "";
      const res = await asyncRequest.list(this.parmValue);
      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list;
        this.pageInfo.total = Number(res.data.count);
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },

    async statusConfirm(id, status) {
      let str = status === "1" ? "禁用" : "启用";
      await this.$confirm("确定要改为" + str + "?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            id: id,
            status: status === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.loading = false;
            this.$notify.success({
              title: "状态修改成功！",
              message: "",
            });
            await this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    // 时间选择事件
    async handleTime(e) {
      if (e.startTime !== "") {
        this.parmValue.start = e.startTime;
      } else {
        this.parmValue.start = "";
      }
      if (e.endTime !== "") {
        this.parmValue.end = e.endTime;
      } else {
        this.parmValue.end = "";
      }
      if (this.parmValue.start !== "" && this.parmValue.end !== "") {
        this.pageInfo.curr = 1;
        this.parmValue.page = 1;
        await this.searchList();
      }
    },
    async customerChange(e) {
      if (e && e.id) {
        this.customerCode = [e.code];
        this.parmValue.customer_code = e.code;
      } else {
        this.customerCode = [];
        this.parmValue.customer_code = "";
      }
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
    },
  },
};
</script>
   <style lang="scss" scoped>
.bargainList {
}
</style>
   